-----------------------------------------------------
-- lua 파일이 여러개인 경우
-- 애드온명, 애드온내공유테이블이 ...으로 전달됨
-----------------------------------------------------
local addonName, L = ...;

-- 움직임 처리할 ActionBar 목록
local LJDActionBarList = {
    --"ActionButton", -- 이동시 심히 이상해 진다. 기본버튼은 손대지 않는걸로..
    "MultiBarLeftButton",
    "MultiBarRightButton",
    "MultiBarBottomLeftButton",
    "MultiBarBottomRightButton",
};

function GetLJDActionBarList()
    return LJDActionBarList;
end

-- 절대좌표를 추출하기 위해 Acchor를 모두 UIParent로 변경한다.
function LJDAnchor_ChangeToUIParent(self)
    -- 화면 좌측하단에서부터의 좌표 및 크기 반환
    local x, y, width, height = self:GetRect();
    -- Anchor 제거 : 이대로 두면 화면에서 사라진다.(기본UI가 Anchor 없는 애들을 숨김처리함)
    self:ClearAllPoints();
    -- UIParent에 Anchor설정.
    self:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT", x, y);
end

-- 이동가능한 액션바 반짝임
function LJDActionBar_Moveable_Show()
    for i,v in ipairs(LJDActionBarList) do
        for j=1,12 do
            local btn= getglobal(v..j);
            --btn.AutoCastShine:Hide();
			--AutoCastShine_AutoCastStop(btn.AutoCastShine);
            --btn.AutoCastable:Hide();
            btn.NewActionTexture:Hide();
            --btn.Name:SetText("|cffff00ff".."".."|r");
            --ActionButton_HideOverlayGlow(btn);  -- 반짝임효과 해제
            
            -- 20201018 9.0.1 patch
            --btn:SetBackdropBorderColor(1,0,0,0);
            if( btn.LJDBackdrop ) then
                btn.LJDBackdrop:SetBackdropBorderColor(1,0,0,0);
            end
            
            if( btn:IsMovable() ) then
      			--btn.AutoCastShine:Show();
                --AutoCastShine_AutoCastStart(btn.AutoCastShine);
                --btn.AutoCastable:Show();
                btn.NewActionTexture:Show();
                --btn.Name:SetText("|cffff00ff"..btn:GetName().."|r");
                --ActionButton_ShowOverlayGlow(btn);  -- 반짝임효과
                
                -- 20201018 9.0.1 patch
                --btn:SetBackdropBorderColor(1,0,0,0.4);
                if( btn.LJDBackdrop ) then
                    btn.LJDBackdrop:SetBackdropBorderColor(1,0,0,0.4);
                end
            end
        end;
    end
end

-- 이동가능한 액션바 반짝임 숨김
function LJDActionBar_Moveable_Hide()
    for i,v in ipairs(LJDActionBarList) do
        for j=1,12 do
            local btn= getglobal(v..j);
            --btn.AutoCastShine:Hide();
            --btn.AutoCastable:Hide();
            btn.NewActionTexture:Hide();
            --btn.Name:SetText("|cffff00ff".."".."|r");
            --ActionButton_HideOverlayGlow(btn);  -- 반짝임효과 해제
            
            -- 20201018 9.0.1 patch
            --btn:SetBackdropBorderColor(1,0,0,0);
            if( btn.LJDBackdrop ) then
                btn.LJDBackdrop:SetBackdropBorderColor(1,0,0,0);
            end
        end;
    end
end

-- 액션바를 이전에 저장한 위치, 크기로 이동 및 변경.
function LJDActionBar_LoadPosition()
    LJDActionButtonPosDB = LJDActionButtonPosDB or {};

    --[[
    for i,v in ipairs(LJDActionBarList) do
        for j=1,12 do
            local btn= getglobal(v..j);
            local btnName = v..j;

            if( LJDActionButtonPosDB[btnName] ) then
                -- 위치
                btn:ClearAllPoints();
                btn:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",LJDActionButtonPosDB[btnName].x, LJDActionButtonPosDB[btnName].y);
                -- 크기
                LJDActionButton_SetSize(btn, LJDActionButtonPosDB[btnName].width, LJDActionButtonPosDB[btnName].height);
            end
        end
    end
    --]]
    
    for btnName, btnPosInfo in pairs(LJDActionButtonPosDB) do
        local btn = getglobal(btnName);
        if( btn and LJDActionButtonPosDB[btnName] ) then
            -- 위치
            btn:ClearAllPoints();
            btn:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",LJDActionButtonPosDB[btnName].x, LJDActionButtonPosDB[btnName].y);
            -- 크기
            LJDActionButton_SetSize(btn, LJDActionButtonPosDB[btnName].width, LJDActionButtonPosDB[btnName].height);
        end
    end
    
    
end

-- 액션바에서 액션버튼들을 이동가능하게 변경
function LJDActionBar_SetMoveable()
    for i,v in ipairs(LJDActionBarList) do
        for j=1,12 do
            local btn= getglobal(v..j);
            LJDActionButton_SetMoveable(btn);    -- 이동가능한 액션버튼으로 변경
            LJDAnchor_ChangeToUIParent(btn);     -- Anchor제거(따라움직이는 아이콘을 없앤다. 모두 각자 움직임처리 및 절대좌표로 변환)
        end;
    end
end

-- 액션바에서 액션버튼들의 크기 초기화
function LJDActionBar_SizeInit()
    for i,v in ipairs(LJDActionBarList) do
        for j=1,12 do
            local btn= getglobal(v..j);
            btn:SetScale(1);
            LJDActionButton_SetSize(btn, 36, 36); -- 크기도 초기화
        end;
    end
end

-- 액션버튼 이동가능하게 변경
function LJDActionButton_SetMoveable(self)
    if( not self) then
        --print("Frame is not exists yet!");
        return;
    end;
    
    -- 이미 설정된 버튼이면 PASS
    if( self.LJDMoveable ) then
        return;
    end

    -- LJD OnDragStart
    local function LJDActionButton_OnDragStart(self)

        ----------------------------------------------------------------------
        -- LJD용 처리구분 추가
        -- 화면로드시 OnDragStop 이벤트가 발생하였다. 
        -- OnDragStop 이벤트에 의해 액션버튼위치가 저장된다. 내꺼도 아닌데..
        -- 걸러야 할 이벤트를 추리기 위해 추가함.
        ----------------------------------------------------------------------
        self.LJDProcgubn = nil;
        
        -- 컨트롤 + 시프트 + 드래그 일때만 이동처리
        if( IsControlKeyDown() and IsShiftKeyDown() ) then
        
            if( IsMouseButtonDown("LeftButton") ) then   -- LeftButton, RightButton, MiddleButton, BUTTON4
                self.LJDProcgubn = "LJDLeftButtonDragStart";
                -- 좌 드래그만 처리할지, 우 드레그만 처리할지.
                -- 좌 드래그가 편하지만, 그만큼 많이 사용될수도 있으므로 고민중.
                -- 일단, 좌로 감.
                self:StartMoving();
            end
            
            if( IsMouseButtonDown("RightButton") ) then   -- LeftButton, RightButton, MiddleButton, BUTTON4
                self.LJDProcgubn = "LJDRightButtonDragStart";
                self:StartSizing();     -- 사이즈변경 드래그 시작
           end
        -- 일반 버튼에 이동기능을 부여한 경우
        -- ; 기본기능 회피위해 추가함.
        elseif( self:GetObjectType() == "Button" ) then
            -- 아무 처리않함.
            
        -- 기본 기능 유지
        -- 시프트 + 드래그는 액션이동
        elseif( IsShiftKeyDown() ) then
            -- 액션 등록/이동
            -- 참조 ActionBarFrame.xml
            
            if ( LOCK_ACTIONBAR ~= "1" or IsModifiedClick("PICKUPACTION") ) then
                SpellFlyout:Hide();
                PickupAction(self.action);
                
                -- 20201018 9.0.1 patch
                --ActionButton_UpdateState(self);
                --ActionButton_UpdateFlash(self);
            end
        end
    end
    
    -- LJD OnDragStop
    local function LJDActionButton_OnDragStop(self)

        -- 액션 등록/이동시에도 이 이벤트가 호출된다.
        -- 여기서 오류나면 게임을 강제종료해야 함.
        -- 아래 메소드호출로 젤 위에 있도록 유지.
        self:StopMovingOrSizing();

        ----------------------------------------------------------------------
        -- 사이즈변경후 보정처리
        ----------------------------------------------------------------------
        if( self.LJDProcgubn and self.LJDProcgubn == "LJDRightButtonDragStart" ) then
            -- 가로, 세로 비율동일하게 크기재조절
            -- 1. 너무 작은 아이콘막기(최소크기 지정)
            -- 2. 가로, 세로중 둘중 큰값으로 고정.
            local curWidth, curHeight = self:GetSize();
            local newSize = math.max(curWidth, curHeight, 20);
            
            -- 크기재지정.
            -- (단, 액션버튼바인 경우만)
            if( self.NewActionTexture ) then
                LJDActionButton_SetSize(self, newSize, newSize);
            end
        end

        ----------------------------------------------------------------------
        -- LJD용 처리구분 추가
        -- 걸러야 할 이벤트를 추리기 위해 추가함.
        -- 이 변수에 값이 있으면.. 내꺼다.
        ----------------------------------------------------------------------
        if( self.LJDProcgubn ) then
            LJDActionButton_SavePosition(self); -- 위치 및 크기 저장.
        end
    end

    -- LJD OnSizeChanged
    local function LJDActionButton_OnSizeChanged(self, width, height)
        -- 크기 바뀔때 반짝임효과 사이즈도 함께변경
        if( self.NewActionTexture ) then
            self.NewActionTexture:SetSize(width, height);
        end
    end

    -- LJD OnEnter
    local function LJDActionButton_OnEnter(self)
        -- 컨트롤 + 시프트 + 드래그 일때만 마우스 커서 변경
        if( IsControlKeyDown() and IsShiftKeyDown() ) then
            SetCursor('INTERACT_CURSOR');
            
            -- 20201018 9.0.1 patch
            --self:SetBackdropBorderColor(1,0,0,0.4);
            if( self.LJDBackdrop ) then
                self.LJDBackdrop:SetBackdropBorderColor(1,0,0,0.4);
            end
        end
    end

    -- LJD OnLeave
    local function LJDActionButton_OnLeave(self)
        -- 컨트롤 + 시프트 + 드래그 일때만 마우스 커서 변경
        if( IsControlKeyDown() and IsShiftKeyDown() ) then
            ResetCursor();
            
            -- 버튼인 경우는 Backdrop 칼라 초기화
            -- ; 액션버튼(CheckButton)외 추가한 버튼들
            -- (Ex, 버튼 초기화, 좌표버튼 등)
            if( self:GetObjectType() == "Button" ) then
                -- 20201018 9.0.1 patch
                --self:SetBackdropBorderColor(1,0,0,0);
                if( self.LJDBackdrop ) then
                    self.LJDBackdrop:SetBackdropBorderColor(1,0,0,0);
                end
            end
        end
    end

    -- LJD OnMouseUp
    local function LJDActionButton_OnMouseUp(self, button)
        -- 20200203 스킬버튼을 옮기는 중 좌클릭 또는 우클릭시
        -- 드래그 상태가 풀리지 않는 버그 수정
        -- ; 어떤 버튼이든 마우스업이 발생되면 드래그 중지처리
        LJDActionButton_OnDragStop(self);
    end

    if self.SetClampedToScreen then
        self:SetClampedToScreen(true);
    end

    self:SetMovable(true);      -- 이동가능 : StartMoving() 사용가능.
    self:SetResizable(true);    -- 크기변경가능 : StartSizing() 사용가능.
    self:EnableMouse(true);
    self:RegisterForDrag("LeftButton", "RightButton");
    self:SetScript("OnDragStart"  , LJDActionButton_OnDragStart  );
    self:SetScript("OnDragStop"   , LJDActionButton_OnDragStop   );
    self:SetScript("OnSizeChanged", LJDActionButton_OnSizeChanged);
    self:SetScript("OnMouseUp"    , LJDActionButton_OnMouseUp    );
    
    -- 아래는 기존의 기본기능을 유지하기 위해 Hook
    self:HookScript("OnEnter"      , LJDActionButton_OnEnter      );
    self:HookScript("OnLeave"      , LJDActionButton_OnLeave      );

    -- 이동시 남겨지는 테두리(필요할때 테두리 표현용)
    -- 20201018 9.0.1 patch
    --self:SetBackdrop({edgeFile='interface/buttons/white8x8', edgeSize=10});
    --self:SetBackdropBorderColor(1,0,0,0)
    self.LJDBackdrop = CreateFrame("Frame", nil, self, BackdropTemplateMixin and "BackdropTemplate")
    self.LJDBackdrop:SetBackdrop({edgeFile='interface/buttons/white8x8', edgeSize=10});
    self.LJDBackdrop:SetBackdropBorderColor(1,0,0,0)

    
    self.LJDMoveable = true;    -- 요걸로 이미 이동가능한 설정되었는지 파악한다.
end

-- 액션버튼 크기 변경
function LJDActionButton_SetSize(self, iWidth, iHeight)
    self:SetSize(iWidth, iHeight);
    if( self.NewActionTexture ) then
        self.NewActionTexture:SetSize(iWidth, iHeight);    -- 수정단축키 눌렀을때 반짝임., 함께 크기 변경
    end
end

-- 액션버튼 위치 저장.
function LJDActionButton_SavePosition(self)
    local curX, curY, curWidth, curHeight = self:GetRect();
    
    LJDActionButtonPosDB[self:GetName()] = {x=curX, y=curY,width=curWidth, height=curHeight};
    
    --print(self:GetName(), LJDActionButtonPosDB[self:GetName()].x, LJDActionButtonPosDB[self:GetName()].y);
end

-- 프레임이동처리
function ChangeMoveableFrame(self)
    if( not self) then
        --print("Frame is not exists yet!");
        return;
    end;
    if self.SetClampedToScreen then
        self:SetClampedToScreen(true);
    end
    self:SetMovable(true);
    self:EnableMouse(true);
    self:RegisterForDrag("LeftButton");
    self:SetScript("OnDragStart", self.StartMoving);
    self:SetScript("OnDragStop", self.StopMovingOrSizing);
end

-- itemLink를 이용하여 내가방 아템보유정보 찾기
function GetContainerItemInfoByItemLink(findItemLink)
    -- 20191123 아이템갯수, 아이템위치(bagId, slot) 출력기능
    -- bagId : 0 = 기본가방(16칸짜리), 1 ~ 4 = 가방번호(오른쪽에서 왼쪽으로)
    local rtnContainerItemInfo = {};
    for bagID=0, 0 do
        for slot=1, 40 do
            local icon, itemCount, locked, quality, readable, lootable, itemLink, isFiltered, noValue, itemID = GetContainerItemInfo(bagID, slot);
            -- 뭔가있는 아이템슬롯이면..
            if( itemLink ) then
                print( "("..bagID..":"..slot..")"..itemLink..":"..itemCount);
                if( findItemLink == itemLink ) then
                    rtnContainerItemInfo = {GetContainerItemInfo(bagID, slot)};
                end
            end
        end
    end

    return rtnContainerItemInfo;
end

-- slot으로 버튼명 찾기
function GetButtonNameBySlot(actionSlot)
    local resultButtonName = "";
    local bars={"Action","MultiBarBottomLeft","MultiBarBottomRight","MultiBarLeft","MultiBarRight"};

    for bar=1,#bars do
        for button=1,12 do
            local buttonName = bars[bar].."Button"..button;

            if _G[buttonName].action == actionSlot then
                --print(buttonName,"contains",GetActionInfo(_G[buttonName].action));
                resultButtonName = buttonName;
                break;
            end
        end
        if resultButtonName ~= "" then
            break;
        end
    end

    return resultButtonName;
end

-- slot, action 보기
function reportActionButtons()
    local lActionSlot = 0;
    for lActionSlot = 1, 120 do
        local lActionText = GetActionText(lActionSlot);
        local lActionTexture = GetActionTexture(lActionSlot);
        if lActionTexture then
            local lMessage = "Slot " .. lActionSlot .. ": [" .. lActionTexture .. "]";
            if lActionText then
                lMessage = lMessage .. " \"" .. lActionText .. "\"";
            end
            DEFAULT_CHAT_FRAME:AddMessage(lMessage);
        end
    end
end

-- 화면 하단 스킬창에 의해 툴팁이 나타낼 최하 위치를 리턴한다.
function getTooltipBottomPosY()
    local StatusBarCount = StatusTrackingBarManager:GetNumberVisibleBars();

    local frame1 = _G["MultiBarBottomLeft"];
    local frame2 = _G["MultiBarBottomRight"];
    local frame3 = _G["PetActionBarFrame"];

    local position = 50;

    if (frame1:IsShown() or frame2:IsShown()) then
        position = position + 60;
    end

    if (frame3:IsShown()) then
        position = position + 40;
    end

    if StatusBarCount == 1 then
        position = position + 15;
    elseif StatusBarCount == 2 then
        position = position + 20;
    end
    
    return tonumber(position);
end

function PlaySound_LootItem()
    --PlaySoundFile("Sound\\interface\\levelup2.ogg", true) --볼륨큼
    --PlaySoundFile("sound\\creature\\aggron1\\VO_60_HIGHMAUL_AGGRON_1_AGGRO_1.ogg");
    --PlaySoundFile("Sound\\Creature\\CThun\\CThunYouWillDIe.ogg");
    --PlaySoundFile("Interface\\AddOns\\GTFO\\Sounds\\alarmbuzz_soft.ogg");

    --PlaySoundFile("Interface\\Addons\\DBM-Core\\sounds\\Corsica\\1.ogg");
    --PlaySoundFile("Interface\\Addons\\DBM-Core\\sounds\\BlakbyrdAlerts\\Alert1.ogg");
    --PlaySoundFile("Interface\\Addons\\DBM-Core\\sounds\\Bear\\1.ogg");
    --PlaySoundFile("Interface\\Addons\\DBM-Core\\sounds\\alarmclockbeeps.ogg");
    --PlaySoundFile("Interface\\AddOns\\GTFO\\Sounds\\alarmbuzz_quiet.ogg");
    --PlaySound(10590, true);
    --PlaySoundFile("Interface\\AddOns\\GTFO\\Sounds\\alarmbuzz_soft.ogg");
    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\Victory\\bbvictory.ogg");
    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\Victory\\SmoothMcGroove_Fanfare.ogg");
    --PlaySoundFile("Sound\\interface\\levelup2.ogg");
    --PlaySound(878);
    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\ClassicSupport\\creature\\HoodWolf\\HoodWolfTransformPlayer01.ogg");
    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\ClassicSupport\\creature\\KilJaeden\\KILJAEDEN02.ogg");
    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\ClassicSupport\\creature\\Illidan\\BLACK_Illidan_04.ogg");
    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\ClassicSupport\\creature\\Illidan_Stormrage\\VO_703_Illidan_Stormrage_03.ogg");

    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\ClassicSupport\\creature\\KilJaeden\\KILJAEDEN02.ogg");

    PlaySound(74702,nil,false); -- 중복허용
    --PlaySound(44330, nil, false); -- 중복허용
    --PlaySound(51401, nil, false); -- 중복허용

    --PlaySound(44330, nil, false); -- 중복허용
    --PlaySound_Success();
end;

function PlaySound_Success()
    --PlaySoundFile("Sound\\interface\\levelup2.ogg", true) --볼륨큼
    --PlaySoundFile("sound\\creature\\aggron1\\VO_60_HIGHMAUL_AGGRON_1_AGGRO_1.ogg");
    --PlaySoundFile("Sound\\Creature\\CThun\\CThunYouWillDIe.ogg");
    --PlaySoundFile("Interface\\AddOns\\GTFO\\Sounds\\alarmbuzz_soft.ogg");

    --PlaySoundFile("Interface\\Addons\\DBM-Core\\sounds\\Corsica\\1.ogg");
    --PlaySoundFile("Interface\\Addons\\DBM-Core\\sounds\\BlakbyrdAlerts\\Alert1.ogg");
    --PlaySoundFile("Interface\\Addons\\DBM-Core\\sounds\\Bear\\1.ogg");
    --PlaySoundFile("Interface\\Addons\\DBM-Core\\sounds\\alarmclockbeeps.ogg");
    --PlaySoundFile("Interface\\AddOns\\GTFO\\Sounds\\alarmbuzz_quiet.ogg");
    --PlaySound(10590, true);
    --PlaySoundFile("Interface\\AddOns\\GTFO\\Sounds\\alarmbuzz_soft.ogg");
    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\Victory\\bbvictory.ogg");
    PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\Victory\\SmoothMcGroove_Fanfare.ogg");
    --PlaySoundFile("Sound\\interface\\levelup2.ogg");
    --PlaySound(878);
    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\ClassicSupport\\creature\\HoodWolf\\HoodWolfTransformPlayer01.ogg");
    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\ClassicSupport\\creature\\KilJaeden\\KILJAEDEN02.ogg");
    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\ClassicSupport\\creature\\Illidan\\BLACK_Illidan_04.ogg");
    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\ClassicSupport\\creature\\Illidan_Stormrage\\VO_703_Illidan_Stormrage_03.ogg");

    --PlaySoundFile("Interface\\AddOns\\DBM-Core\\sounds\\ClassicSupport\\creature\\KilJaeden\\KILJAEDEN02.ogg");

    --PlaySound(74702,nil,false); -- 중복허용
    --PlaySound(44330, nil, false); -- 중복허용
    --PlaySound(51401, nil, false); -- 중복허용

    --PlaySound(44330, nil, false); -- 중복허용

end;

function SendMsg(strMsg)

    --print(strMsg);
    --print(CombatLogGetCurrentEventInfo());


    SendChatMessage(strMsg, "say");
    --SendChatMessage(strMsg, "yell");
    --SendChatMessage(strMsg, "party");
    --SendChatMessage(strMsg, "whisper", nil,UnitName("player"))
end;

-- CVar변경
function LJDSetCVarVariables()
    --
    --큰이름표 크기 조금 작게하기
    SetCVar("nameplateGlobalScale"      , 1     );  -- 이름표 전체적 크기(기본값 : 1.0)
    SetCVar("nameplateMinScale"         , 0.7   );  -- 대상이 멀리   있을때 이름표 크기(기본값 : 0.8)
    SetCVar("nameplateMaxScale"         , 0.9   );  -- 대상이 가까이 있을때 이름표 크기(기본값 : 1.0)
    SetCVar("nameplateSelfScale"        , 0.9   );  -- 화면중앙 내 케릭터 체력과 마나(기본값 : 1.0)
    SetCVar("nameplateSelectedScale"    , 0.9   );  -- 대상의 이름표 크기(기본값 : 1.0)
    SetCVar("nameplateLargerScale"      , 1.1   );  -- 던젼내 보스몹의 이름표크기(기본값 : 1.2)

    SetCVar("UnitNameNPC"               , 1     );  -- NPC 이름표 표시(기본값 : 0)
    SetCVar("nameplateShowFriendlyNPCs" , 1     );  -- NPC 체력바 표시(기본값 : 0)
    SetCVar("nameplateOverlapV"         , 0.7   );  -- 이름표수직 간격(기본값 : 1.1)
    SetCVar("nameplateMaxDistance"      , 100   );  -- 이름표 표시할 최대사거리(기본값 : 60) -- (멀리하면 화면 많이 가림...특정 케릭 찾기는 좋음)
    SetCVar("nameplateShowOnlyNames"    , 0     );  -- 체력바 숨기기(기본값 : 0) -- (Npc 및 아군만)

    SetCVar("showTutorials"             , 0     );  -- 와우기본도움말(저렙도움말) 표시
    SetCVar("nameplateOccludedAlphaMult", 0.4   );  -- 장애물뒤이름표 흐리게 표현(기본값 : 0.4)
    SetCVar("scriptErrors"              , 1     );  -- 애드온에러 표현(기본값 : 0)

    -- 20191127 보스몹등, 큰 몹들의 디버프 툴팁이 짤리는 현상 관련.
    -- 주) TopInset : 0.1인 경우의 의미
    -- ; 화면 젤 위에서부터 10% 아래위치. 마우스를 이리저리 돌려도 Target이름표는 그 자리 위로 올라가지 못하게 고정됨.
    --SetCVar("nameplateLargeTopInset"    , 0.19  );  -- (Target 지정된)보스몹의 이름표의 화면 상단 이동한계(기본값 : 0.1) -- 진득주, 값은 퍼센트, 클수록 아래로 내리기.
    --SetCVar("nameplateOtherTopInset"    , 0.08  );  -- (Target 지정된)일반이름표의 화면 상단 이동한계(기본값 : 0.08) -- 진득주, 값은 퍼센트, 클수록 아래로 내리기
    
    -- 20191128
    -- 초기값으로 돌림, 화면 상단에 아이콘이 있으면 툴팁을 아래로 표현하도록함.
    --SetCVar("nameplateLargeTopInset"    , 0.1   );  -- 던젼내 보스몹의 이름표크기 화면 상단 한계치(기본값 : 0.1) -- 진득주, 값은 퍼센트, 클수록 아래로 내리기
    --SetCVar("nameplateOtherTopInset"    , 0.08  );  -- 일반이름표의 화면 상단부 한계(기본값 : 0.08) -- 진득주, 값은 퍼센트, 클수록 아래로 내리기
    -------------------------------------------------------------
    -- 20191127 이름표 세로 사이즈를 조금 줄이기 시도!!
    -- 안하는게 좋겠다. 
    -- 인터페이스 설정갔다왔다 할경우 설정이 원래값으로 돌아감. 
    -- 두번 Reload시 다시 적용되지만...안하기로 함.
    -------------------------------------------------------------
    --SetCVar("NameplateHorizontalScale"  , 1.4   );  -- 이름표 가로 크기(기본값 : 1)
    --SetCVar("NameplateVerticalScale"    , 2.0   );  -- 이름표 세로 크기(기본값 : 1)
    --SetCVar("nameplateOverlapV"         , 0.6   );  -- 이름표수직 간격(기본값 : 1.1)
    
    --SetCVar("nameplateLargeTopInset"    , 0.1   );  -- 던젼내 보스몹의 이름표크기 화면 상단 한계치(기본값 : 0.1) -- 진득주, 값은 퍼센트, 클수록 아래로 내리기
    --SetCVar("nameplateOtherTopInset"    , 0.08  );  -- 일반이름표의 화면 상단부 한계(기본값 : 0.08) -- 진득주, 값은 퍼센트, 클수록 아래로 내리기
    -------------------------------------------------------------
    
    --]]

end

--CVar 복원
function LJDRestoreCVarVariables()
    SetCVar("nameplateGlobalScale"      , GetCVarDefault("nameplateGlobalScale"      ));  -- 이름표 전체적 크기(기본값 : 1.0)
    SetCVar("nameplateMinScale"         , GetCVarDefault("nameplateMinScale"         ));  -- 대상이 멀리   있을때 이름표 크기(기본값 : 0.8)
    SetCVar("nameplateMaxScale"         , GetCVarDefault("nameplateMaxScale"         ));  -- 대상이 가까이 있을때 이름표 크기(기본값 : 1.0)
    SetCVar("nameplateSelfScale"        , GetCVarDefault("nameplateSelfScale"        ));  -- 화면중앙 내 케릭터 체력과 마나(기본값 : 1.0)
    SetCVar("nameplateSelectedScale"    , GetCVarDefault("nameplateSelectedScale"    ));  -- 대상의 이름표 크기(기본값 : 1.0)
    SetCVar("nameplateLargerScale"      , GetCVarDefault("nameplateLargerScale"      ));  -- 던젼내 보스몹의 이름표크기(기본값 : 1.2)

    SetCVar("UnitNameNPC"               , GetCVarDefault("UnitNameNPC"               ));  -- NPC 이름표 표시(기본값 : 0)
    SetCVar("nameplateShowFriendlyNPCs" , GetCVarDefault("nameplateShowFriendlyNPCs" ));  -- NPC 체력바 표시(기본값 : 0)
    SetCVar("nameplateOverlapV"         , GetCVarDefault("nameplateOverlapV"         ));  -- 이름표수직 간격(기본값 : 1.1)
    SetCVar("nameplateMaxDistance"      , GetCVarDefault("nameplateMaxDistance"      ));  -- 이름표 표시할 최대사거리(기본값 : 60) -- (멀리하면 화면 많이 가림...특정 케릭 찾기는 좋음)
    SetCVar("nameplateShowOnlyNames"    , GetCVarDefault("nameplateShowOnlyNames"    ));  -- 체력바 숨기기(기본값 : 0) -- (Npc 및 아군만)

    SetCVar("showTutorials"             , GetCVarDefault("showTutorials"             ));  -- 와우기본도움말(저렙도움말) 표시
    SetCVar("nameplateOccludedAlphaMult", GetCVarDefault("nameplateOccludedAlphaMult"));  -- 장애물뒤이름표 흐리게 표현(기본값 : 0.4)
    SetCVar("scriptErrors"              , GetCVarDefault("scriptErrors"              ));  -- 애드온에러 표현(기본값 : 0)

    SetCVar("nameplateLargeTopInset"    , GetCVarDefault("nameplateLargeTopInset"    ));  -- 던젼내 보스몹의 이름표크기 화면 상단 한계치(기본값 : 0.1) -- 진득주, 값은 퍼센트, 클수록 아래로 내리기
    SetCVar("nameplateOtherTopInset"    , GetCVarDefault("nameplateOtherTopInset"    ));  -- 일반이름표의 화면 상단부 한계(기본값 : 0.08) -- 진득주, 값은 퍼센트, 클수록 아래로 내리기
end

-- 케릭의 Classcolor가 적용된 유닉명을 리턴한다.
-- ex) print(LJDGetClassColoredName("target"));
--     print(LJDGetClassColoredName("target", "바꿀이름"));
function LJDGetClassColoredName(unitId, newName)

    if( not newName ) then
        newName = UnitName(unitId);
    end

    local className, classFilename, classID = UnitClass(unitId);
    local rPerc, gPerc, bPerc, argbHex = GetClassColor(classFilename);
    
    local coloredName = nil;
    if( UnitExists(unitId) ) then
        coloredName = "|c"..argbHex.."" .. newName .. "|r";
    end
    
    --return UnitName(unitId) and coloredName or "";
    return coloredName;
end

-- SpellLink를 원하는 색으로 표현하고 싶을때(ARGB)
-- ex) print(LJDGetSpellLink("266146", "ff71d5ff"));
function LJDGetSpellLink(startSpellId, argbHex)
    -- 기본색 지정
    if( not argbHex ) then
        argbHex = "ff71d5ff";   -- 하늘색
    end
    
    local name, rank, icon, castTime, minRange, maxRange, spellId = GetSpellInfo(startSpellId);

    --local spellLink = "|Hspell:" .. spellId .."|h|r|cff71d5ff[" .. name .. "" .. (rank or "") .. "]|r|h";
    return "|Hspell:" .. spellId .."|h|r|c"..argbHex.."[" .. name .. "" .. (rank or "") .. "]|r|h";
end


--[[
HighScore = { Robin = 8, Jon = 10, Max = 11 }

-- basic usage, just sort by the keys
for k,v in spairs(HighScore) do
    print(k,v)
end
--> Jon     10
--> Max     11
--> Robin   8

-- this uses an custom sorting function ordering by score descending
for k,v in spairs(HighScore, function(t,a,b) return t[b] < t[a] end) do
    print(k,v)
end
--> Max     11
--> Jon     10
--> Robin   8
--]]
-- 단순 Key 값으로 정렬기능
-- 진득주)
-- 1. table.sort를 이용한 정렬은 단순 List 형태(index-value)만 가능하다. ex. {"일","이","삼"}
-- 2. table.sort는 List형이 아니면 sort함수를 지정하더라도 반응하지 않는다.
-- 3. table(key-value)에 순차적으로 값을 넣는다고 해도 순서는 보장 받지 못한다.
-- 종합적으로, 순서보장을 위해서는 List형태(index-value)를 사용하고,
-- 저장된 데이터는 가공할수 없으므로 아래처럼 순차적으로 꺼내는 함수를 이용함.
function LJDSortPairs(t, order)
    -- collect the keys
    local keys = {}
    
    for k in pairs(t) do keys[#keys+1] = k end

    -- if order function given, sort by it by passing the table and keys a, b,
    -- otherwise just sort the keys 
    if order then
        table.sort(keys, function(a,b) return order(t, a, b) end)
    else
        table.sort(keys)
    end

    -- return the iterator function
    local i = 0
    return function()
        i = i + 1
        if keys[i] then
            return keys[i], t[keys[i] ]
        end
    end
end

-- 아래 함수는 레시피의 출력순서를 전문기술별로 정한다.
-- table.sort 사용을 고려하였으나 table.sort 불안정함 문제로 사용안함.
function LJDSortPairsByKeyTable(orgTable, sortedKeyTable)

    if( not sortedKeyTable ) then
        return nil;
    end

    --------------------------------------------
    -- iterator function Start
    --------------------------------------------
    local i = 0;
    local function LJDIterFunc()
        i = i + 1;
        
        -- 이경우는 있을수 없으나 안전빵
        if not sortedKeyTable[i] then
            return nil;
        end
        
        -- sortedKeyTable 에만 있는 경우
        -- orgTable 에서 순차적으로 찾는다.
        if( not orgTable[ sortedKeyTable[i] ] ) then
            for j=i, #sortedKeyTable do
                i = j;  -- i 증가(찾을때까지)
                if( orgTable[ sortedKeyTable[i] ] ) then
                    break;
                end
            end
        end

        -- orgTable 에서 찾아봤지만 없는 경우를 감안하여..ex. 고고학
        if not orgTable[ sortedKeyTable[i] ] then
            return nil;
        end

        -- row 리턴
        return sortedKeyTable[i], orgTable[ sortedKeyTable[i] ];
    end
    --------------------------------------------
    -- iterator function End
    --------------------------------------------
    return LJDIterFunc;
end


